diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-remote-station-manager.h ns-3.45/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.44/src/wifi/model/wifi-remote-station-manager.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-remote-station-manager.h	2025-06-01 20:34:45.631702200 -0700
@@ -18,13 +18,17 @@
 #include "ns3/common-info-basic-mle.h"
 #include "ns3/data-rate.h"
 #include "ns3/eht-capabilities.h"
+#include "ns3/eht-operation.h"
 #include "ns3/he-6ghz-band-capabilities.h"
 #include "ns3/he-capabilities.h"
+#include "ns3/he-operation.h"
 #include "ns3/ht-capabilities.h"
+#include "ns3/ht-operation.h"
 #include "ns3/mac48-address.h"
 #include "ns3/object.h"
 #include "ns3/traced-callback.h"
 #include "ns3/vht-capabilities.h"
+#include "ns3/vht-operation.h"
 
 #include <array>
 #include <list>
@@ -106,13 +110,17 @@
     bool m_erpOfdmSupported;           //!< Flag if ERP OFDM is supported by the remote station
     bool m_ofdmSupported;              //!< Flag if OFDM is supported by the remote station
     Ptr<const HtCapabilities> m_htCapabilities; //!< remote station HT capabilities
+    Ptr<const HtOperation> m_htOperation;       //!< remote station HT operation
     Ptr<const ExtendedCapabilities>
         m_extendedCapabilities;                   //!< remote station extended capabilities
     Ptr<const VhtCapabilities> m_vhtCapabilities; //!< remote station VHT capabilities
+    Ptr<const VhtOperation> m_vhtOperation;       //!< remote station VHT operation
     Ptr<const HeCapabilities> m_heCapabilities;   //!< remote station HE capabilities
+    Ptr<const HeOperation> m_heOperation;         //!< remote station HE operation
     Ptr<const He6GhzBandCapabilities>
         m_he6GhzBandCapabilities;                 //!< remote station HE 6GHz band capabilities
     Ptr<const EhtCapabilities> m_ehtCapabilities; //!< remote station EHT capabilities
+    Ptr<const EhtOperation> m_ehtOperation;       //!< remote station EHT operation
     /// remote station Multi-Link Element Common Info
     std::shared_ptr<CommonInfoBasicMle> m_mleCommonInfo;
     bool m_emlsrEnabled; //!< whether EMLSR mode is enabled on this link
@@ -254,6 +262,13 @@
      */
     void AddStationHtCapabilities(Mac48Address from, const HtCapabilities& htCapabilities);
     /**
+     * Records HT operation of the remote station.
+     *
+     * @param from the address of the station being recorded
+     * @param htOperation the HT operation of the station
+     */
+    void AddStationHtOperation(Mac48Address from, const HtOperation& htOperation);
+    /**
      * Records extended capabilities of the remote station.
      *
      * @param from the address of the station being recorded
@@ -269,6 +284,13 @@
      */
     void AddStationVhtCapabilities(Mac48Address from, const VhtCapabilities& vhtCapabilities);
     /**
+     * Records VHT operation of the remote station.
+     *
+     * @param from the address of the station being recorded
+     * @param vhtOperation the VHT operation of the station
+     */
+    void AddStationVhtOperation(Mac48Address from, const VhtOperation& vhtOperation);
+    /**
      * Records HE capabilities of the remote station.
      *
      * @param from the address of the station being recorded
@@ -276,6 +298,13 @@
      */
     void AddStationHeCapabilities(Mac48Address from, const HeCapabilities& heCapabilities);
     /**
+     * Records HE operation of the remote station.
+     *
+     * @param from the address of the station being recorded
+     * @param heOperation the HE operation of the station
+     */
+    void AddStationHeOperation(Mac48Address from, const HeOperation& heOperation);
+    /**
      * Records HE 6 GHz Band Capabilities of a remote station
      *
      * @param from the address of the remote station
@@ -291,6 +320,13 @@
      */
     void AddStationEhtCapabilities(Mac48Address from, const EhtCapabilities& ehtCapabilities);
     /**
+     * Records EHT operation of the remote station.
+     *
+     * @param from the address of the station being recorded
+     * @param ehtOperation the EHT operation of the station
+     */
+    void AddStationEhtOperation(Mac48Address from, const EhtOperation& ehtOperation);
+    /**
      * Records the Common Info field advertised by the given remote station in a Multi-Link
      * Element. It includes the MLD address of the remote station.
      *
@@ -307,6 +343,13 @@
      */
     Ptr<const HtCapabilities> GetStationHtCapabilities(Mac48Address from);
     /**
+     * Return the HT operation sent by the remote station.
+     *
+     * @param from the address of the remote station
+     * @return the HT operation sent by the remote station
+     */
+    Ptr<const HtOperation> GetStationHtOperation(Mac48Address from);
+    /**
      * Return the extended capabilities sent by the remote station.
      *
      * @param from the address of the remote station
@@ -321,6 +364,13 @@
      */
     Ptr<const VhtCapabilities> GetStationVhtCapabilities(Mac48Address from);
     /**
+     * Return the VHT operation sent by the remote station.
+     *
+     * @param from the address of the remote station
+     * @return the VHT operation sent by the remote station
+     */
+    Ptr<const VhtOperation> GetStationVhtOperation(Mac48Address from);
+    /**
      * Return the HE capabilities sent by the remote station.
      *
      * @param from the address of the remote station
@@ -328,6 +378,13 @@
      */
     Ptr<const HeCapabilities> GetStationHeCapabilities(Mac48Address from);
     /**
+     * Return the HE operation sent by the remote station.
+     *
+     * @param from the address of the remote station
+     * @return the HE operation sent by the remote station
+     */
+    Ptr<const HeOperation> GetStationHeOperation(Mac48Address from);
+    /**
      * Return the HE 6 GHz Band Capabilities sent by a remote station.
      *
      * @param from the address of the remote station
@@ -342,6 +399,13 @@
      */
     Ptr<const EhtCapabilities> GetStationEhtCapabilities(Mac48Address from);
     /**
+     * Return the EHT operation sent by the remote station.
+     *
+     * @param from the address of the remote station
+     * @return the EHT operation sent by the remote station
+     */
+    Ptr<const EhtOperation> GetStationEhtOperation(Mac48Address from);
+    /**
      * @param from the (MLD or link) address of the remote non-AP MLD
      * @return the EML Capabilities advertised by the remote non-AP MLD
      */
@@ -890,6 +954,16 @@
      */
     WifiTxVector GetCtsToSelfTxVector();
     /**
+     * Adjust the TXVECTOR for a control response frame to ensure that, if appropriate, the non-HT
+     * duplicate format is used and the TX width matches that of the data frame transmitted (in case
+     * of, e.g., Ack or BlockAck) or to transmit (in case of, e.g., RTS or BlockAckReq) in the same
+     * frame exchange sequence.
+     *
+     * @param txVector the TXVECTOR to adjust
+     * @param allowedWidth the allowed width for the data frame in the same frame exchange sequence
+     */
+    void AdjustTxVectorForCtlResponse(WifiTxVector& txVector, MHz_u allowedWidth) const;
+    /**
      * Adjust the TXVECTOR for an initial Control frame to ensure that the modulation class
      * is non-HT and the rate is 6 Mbps, 12 Mbps or 24 Mbps.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-ru.cc ns-3.45/src/wifi/model/wifi-ru.cc
--- ns-3.44/src/wifi/model/wifi-ru.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/wifi/model/wifi-ru.cc	2025-06-01 20:34:45.631702200 -0700
@@ -0,0 +1,266 @@
+/*
+ * Copyright (c) 2024
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "wifi-ru.h"
+
+#include <algorithm>
+
+namespace ns3
+{
+
+WifiRu::RuSpecCompare::RuSpecCompare(MHz_u channelWidth, uint8_t p20Index)
+    : m_channelWidth(channelWidth),
+      m_p20Index(p20Index)
+{
+}
+
+bool
+WifiRu::RuSpecCompare::operator()(const RuSpec& lhs, const RuSpec& rhs) const
+{
+    const auto lhsIndex = WifiRu::GetPhyIndex(lhs, m_channelWidth, m_p20Index);
+    const auto rhsIndex = WifiRu::GetPhyIndex(rhs, m_channelWidth, m_p20Index);
+    const auto lhsStartTone =
+        WifiRu::GetSubcarrierGroup(m_channelWidth,
+                                   WifiRu::GetRuType(lhs),
+                                   lhsIndex,
+                                   WifiRu::IsHe(lhs) ? WIFI_MOD_CLASS_HE : WIFI_MOD_CLASS_EHT)
+            .front()
+            .first;
+    const auto rhsStartTone =
+        WifiRu::GetSubcarrierGroup(m_channelWidth,
+                                   WifiRu::GetRuType(rhs),
+                                   rhsIndex,
+                                   WifiRu::IsHe(lhs) ? WIFI_MOD_CLASS_HE : WIFI_MOD_CLASS_EHT)
+            .front()
+            .first;
+    return lhsStartTone < rhsStartTone;
+}
+
+RuType
+WifiRu::GetRuType(RuSpec ruVariant)
+{
+    return std::visit([&](auto&& ru) { return ru.GetRuType(); }, ruVariant);
+}
+
+std::size_t
+WifiRu::GetIndex(RuSpec ruVariant)
+{
+    return std::visit([&](auto&& ru) { return ru.GetIndex(); }, ruVariant);
+}
+
+std::size_t
+WifiRu::GetPhyIndex(RuSpec ruVariant, MHz_u bw, uint8_t p20Index)
+{
+    return std::visit([&](auto&& ru) { return ru.GetPhyIndex(bw, p20Index); }, ruVariant);
+}
+
+RuType
+WifiRu::GetMaxRuType(WifiModulationClass mc)
+{
+    switch (mc)
+    {
+    case WIFI_MOD_CLASS_HE:
+        return RuType::RU_2x996_TONE;
+    case WIFI_MOD_CLASS_EHT:
+        return RuType::RU_4x996_TONE;
+    default:
+        NS_ABORT_MSG("Unknown modulation class: " << mc);
+        return RuType::RU_TYPE_MAX;
+    }
+}
+
+MHz_u
+WifiRu::GetBandwidth(RuType ruType)
+{
+    switch (ruType)
+    {
+    case RuType::RU_26_TONE:
+        return MHz_u{2};
+    case RuType::RU_52_TONE:
+        return MHz_u{4};
+    case RuType::RU_106_TONE:
+        return MHz_u{8};
+    case RuType::RU_242_TONE:
+        return MHz_u{20};
+    case RuType::RU_484_TONE:
+        return MHz_u{40};
+    case RuType::RU_996_TONE:
+        return MHz_u{80};
+    case RuType::RU_2x996_TONE:
+        return MHz_u{160};
+    case RuType::RU_4x996_TONE:
+        return MHz_u{320};
+    default:
+        NS_ABORT_MSG("RU type " << ruType << " not found");
+        return MHz_u{0};
+    }
+}
+
+RuType
+WifiRu::GetRuType(MHz_u bandwidth)
+{
+    switch (static_cast<uint16_t>(bandwidth))
+    {
+    case 2:
+        return RuType::RU_26_TONE;
+    case 4:
+        return RuType::RU_52_TONE;
+    case 8:
+        return RuType::RU_106_TONE;
+    case 20:
+        return RuType::RU_242_TONE;
+    case 40:
+        return RuType::RU_484_TONE;
+    case 80:
+        return RuType::RU_996_TONE;
+    case 160:
+        return RuType::RU_2x996_TONE;
+    case 320:
+        return RuType::RU_4x996_TONE;
+    default:
+        NS_ABORT_MSG(bandwidth << " bandwidth not found");
+        return RuType::RU_TYPE_MAX;
+    }
+}
+
+std::size_t
+WifiRu::GetNRus(MHz_u bw, RuType ruType, WifiModulationClass mc)
+{
+    if (ruType > GetMaxRuType(mc))
+    {
+        return 0;
+    }
+    return (mc == WIFI_MOD_CLASS_HE) ? HeRu::GetNRus(bw, ruType) : EhtRu::GetNRus(bw, ruType);
+}
+
+SubcarrierGroup
+WifiRu::GetSubcarrierGroup(MHz_u bw, RuType ruType, std::size_t phyIndex, WifiModulationClass mc)
+{
+    return (mc == WIFI_MOD_CLASS_HE) ? HeRu::GetSubcarrierGroup(bw, ruType, phyIndex)
+                                     : EhtRu::GetSubcarrierGroup(bw, ruType, phyIndex);
+}
+
+uint16_t
+WifiRu::GetEqualizedRuAllocation(RuType ruType, bool isOdd, bool hasUsers, WifiModulationClass mc)
+{
+    return (mc == WIFI_MOD_CLASS_HE) ? HeRu::GetEqualizedRuAllocation(ruType, isOdd, hasUsers)
+                                     : EhtRu::GetEqualizedRuAllocation(ruType, isOdd, hasUsers);
+}
+
+std::vector<WifiRu::RuSpec>
+WifiRu::GetRuSpecs(uint16_t ruAllocation, WifiModulationClass mc)
+{
+    std::vector<RuSpec> ruSpecs;
+    if (mc == WIFI_MOD_CLASS_HE)
+    {
+        auto heRuSpecs = HeRu::GetRuSpecs(ruAllocation);
+        std::copy(heRuSpecs.begin(), heRuSpecs.end(), std::back_inserter(ruSpecs));
+    }
+    else
+    {
+        auto ehtRuSpecs = EhtRu::GetRuSpecs(ruAllocation);
+        std::copy(ehtRuSpecs.begin(), ehtRuSpecs.end(), std::back_inserter(ruSpecs));
+    }
+    return ruSpecs;
+}
+
+std::vector<WifiRu::RuSpec>
+WifiRu::GetRusOfType(MHz_u bw, RuType ruType, WifiModulationClass mc)
+{
+    std::vector<RuSpec> rus;
+    if (mc == WIFI_MOD_CLASS_HE)
+    {
+        auto heRuSpecs = HeRu::GetRusOfType(bw, ruType);
+        std::copy(heRuSpecs.begin(), heRuSpecs.end(), std::back_inserter(rus));
+    }
+    else
+    {
+        auto ehtRuSpecs = EhtRu::GetRusOfType(bw, ruType);
+        std::copy(ehtRuSpecs.begin(), ehtRuSpecs.end(), std::back_inserter(rus));
+    }
+    return rus;
+}
+
+std::vector<WifiRu::RuSpec>
+WifiRu::GetCentral26TonesRus(MHz_u bw, RuType ruType, WifiModulationClass mc)
+{
+    std::vector<RuSpec> central26TonesRus;
+    if (mc == WIFI_MOD_CLASS_HE)
+    {
+        auto heRuSpecs = HeRu::GetCentral26TonesRus(bw, ruType);
+        std::copy(heRuSpecs.begin(), heRuSpecs.end(), std::back_inserter(central26TonesRus));
+    }
+    else
+    {
+        auto ehtRuSpecs = EhtRu::GetCentral26TonesRus(bw, ruType);
+        std::copy(ehtRuSpecs.begin(), ehtRuSpecs.end(), std::back_inserter(central26TonesRus));
+    }
+    return central26TonesRus;
+}
+
+bool
+WifiRu::DoesOverlap(MHz_u bw, RuSpec ru, const std::vector<RuSpec>& v)
+{
+    if (IsHe(ru))
+    {
+        std::vector<HeRu::RuSpec> heRus;
+        std::transform(v.cbegin(), v.cend(), std::back_inserter(heRus), [](const auto& heRu) {
+            return std::get<HeRu::RuSpec>(heRu);
+        });
+        return HeRu::DoesOverlap(bw, std::get<HeRu::RuSpec>(ru), heRus);
+    }
+
+    std::vector<EhtRu::RuSpec> ehtRus;
+    std::transform(v.cbegin(), v.cend(), std::back_inserter(ehtRus), [](const auto& ehtRu) {
+        return std::get<EhtRu::RuSpec>(ehtRu);
+    });
+    return EhtRu::DoesOverlap(bw, std::get<EhtRu::RuSpec>(ru), ehtRus);
+}
+
+WifiRu::RuSpec
+WifiRu::FindOverlappingRu(MHz_u bw, RuSpec referenceRu, RuType searchedRuType)
+{
+    return IsHe(referenceRu) ? RuSpec{HeRu::FindOverlappingRu(bw,
+                                                              std::get<HeRu::RuSpec>(referenceRu),
+                                                              searchedRuType)}
+                             : RuSpec{EhtRu::FindOverlappingRu(bw,
+                                                               std::get<EhtRu::RuSpec>(referenceRu),
+                                                               searchedRuType)};
+}
+
+RuType
+WifiRu::GetEqualSizedRusForStations(MHz_u bandwidth,
+                                    std::size_t& nStations,
+                                    std::size_t& nCentral26TonesRus,
+                                    WifiModulationClass mc)
+{
+    return (mc == WIFI_MOD_CLASS_HE)
+               ? HeRu::GetEqualSizedRusForStations(bandwidth, nStations, nCentral26TonesRus)
+               : EhtRu::GetEqualSizedRusForStations(bandwidth, nStations, nCentral26TonesRus);
+}
+
+bool
+WifiRu::IsHe(RuSpec ru)
+{
+    return std::holds_alternative<HeRu::RuSpec>(ru);
+}
+
+bool
+WifiRu::IsEht(RuSpec ru)
+{
+    return std::holds_alternative<EhtRu::RuSpec>(ru);
+}
+
+std::ostream&
+operator<<(std::ostream& os, const WifiRu::RuSpec& ruVariant)
+{
+    std::visit([&os](auto&& arg) { os << arg; }, ruVariant);
+    return os;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-ru.h ns-3.45/src/wifi/model/wifi-ru.h
--- ns-3.44/src/wifi/model/wifi-ru.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/wifi/model/wifi-ru.h	2025-06-01 20:34:45.631702200 -0700
@@ -0,0 +1,251 @@
+/*
+ * Copyright (c) 2024
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef WIFI_RU_H
+#define WIFI_RU_H
+
+#include "ns3/eht-ru.h"
+#include "ns3/he-ru.h"
+
+#include <variant>
+
+namespace ns3
+{
+
+/**
+ * This class handles RU variants.
+ */
+class WifiRu
+{
+  public:
+    /// variant of the RU specification
+    using RuSpec = std::variant<HeRu::RuSpec, EhtRu::RuSpec>;
+
+    /**
+     * Struct providing a function call operator to compare two RUs.
+     */
+    struct RuSpecCompare
+    {
+        /**
+         * Constructor.
+         *
+         * @param channelWidth the channel width
+         * @param p20Index the index of the primary20 channel
+         */
+        RuSpecCompare(MHz_u channelWidth, uint8_t p20Index);
+        /**
+         * Function call operator.
+         *
+         * @param lhs left hand side RU
+         * @param rhs right hand side RU
+         * @return true if the left hand side RU has its leftmost tone at a lower
+         *         frequency than the leftmost tone of the right hand side RU,
+         *         false otherwise
+         */
+        bool operator()(const RuSpec& lhs, const RuSpec& rhs) const;
+
+      private:
+        MHz_u m_channelWidth; ///< The channel width
+        uint8_t m_p20Index;   ///< Primary20 channel index
+    };
+
+    /**
+     * Get the type of a given RU
+     *
+     * @param ru the RU variant
+     * @return the RU type
+     */
+    static RuType GetRuType(RuSpec ru);
+
+    /**
+     * Get the index of a given RU
+     *
+     * @param ru the RU variant
+     * @return the RU index
+     */
+    static std::size_t GetIndex(RuSpec ru);
+
+    /**
+     * Get the RU PHY index
+     *
+     * @param ru the RU variant
+     * @param bw the width of the channel of which the RU is part
+     * @param p20Index the index of the primary20 channel
+     * @return the RU PHY index
+     */
+    static std::size_t GetPhyIndex(RuSpec ru, MHz_u bw, uint8_t p20Index);
+
+    /**
+     * Get the approximate bandwidth occupied by a RU.
+     *
+     * @param ruType the RU type
+     * @return the approximate bandwidth occupied by the RU
+     */
+    static MHz_u GetBandwidth(RuType ruType);
+
+    /**
+     * Get the RU corresponding to the approximate bandwidth.
+     *
+     * @param bandwidth the approximate bandwidth occupied by the RU
+     * @return the RU type
+     */
+    static RuType GetRuType(MHz_u bandwidth);
+
+    /**
+     * Get the number of distinct RUs of the given type (number of tones)
+     * available in a PPDU of the given bandwidth.
+     *
+     * @param bw the bandwidth of the PPDU
+     * @param ruType the RU type (number of tones)
+     * @param mc the modulation class of the PPDU
+     * @return the number of distinct RUs available
+     */
+    static std::size_t GetNRus(MHz_u bw, RuType ruType, WifiModulationClass mc);
+
+    /**
+     * Get the subcarrier group of the RU having the given PHY index among all the
+     * RUs of the given type (number of tones) available in a PPDU of the
+     * given bandwidth. A subcarrier group is defined as one or more pairs
+     * indicating the lowest frequency index and the highest frequency index.
+     *
+     * @param bw the bandwidth of the PPDU
+     * @param ruType the RU type (number of tones)
+     * @param phyIndex the PHY index (starting at 1) of the RU
+     * @param mc the modulation class of the PPDU
+     * @return the subcarrier range of the specified RU
+     */
+    static SubcarrierGroup GetSubcarrierGroup(MHz_u bw,
+                                              RuType ruType,
+                                              std::size_t phyIndex,
+                                              WifiModulationClass mc);
+
+    /**
+     * Get the RU_ALLOCATION value for equal size RUs
+     *
+     * @param ruType equal size RU type (generated by GetEqualSizedRusForStations)
+     * @param isOdd if number of stations is an odd number
+     * @param hasUsers whether it contributes to User field(s) in the content channel this RU
+     * Allocation belongs to
+     * @param mc the modulation class of the PPDU
+     * @return RU_ALLOCATION value
+     */
+    static uint16_t GetEqualizedRuAllocation(RuType ruType,
+                                             bool isOdd,
+                                             bool hasUsers,
+                                             WifiModulationClass mc);
+
+    /**
+     * Get the RU specs based on RU_ALLOCATION
+     *
+     * @param ruAllocation 9 bit RU_ALLOCATION value
+     * @param mc the modulation class of the PPDU
+     * @return RU spec associated with the RU_ALLOCATION
+     */
+    static std::vector<RuSpec> GetRuSpecs(uint16_t ruAllocation, WifiModulationClass mc);
+
+    /**
+     * Get the set of distinct RUs of the given type (number of tones)
+     * available in an MU PPDU of the given bandwidth.
+     *
+     * @param bw the bandwidth of the PPDU
+     * @param ruType the RU type (number of tones)
+     * @param mc the modulation class of the PPDU
+     * @return the set of distinct RUs available
+     */
+    static std::vector<RuSpec> GetRusOfType(MHz_u bw, RuType ruType, WifiModulationClass mc);
+
+    /**
+     * Get the set of 26-tone RUs that can be additionally allocated if the given
+     * bandwidth is split in RUs of the given type.
+     *
+     * @param bw the bandwidth of the PPDU
+     * @param ruType the RU type (number of tones)
+     * @param mc the modulation class of the PPDU
+     * @return the set of 26-tone RUs that can be additionally allocated
+     */
+    static std::vector<RuSpec> GetCentral26TonesRus(MHz_u bw,
+                                                    RuType ruType,
+                                                    WifiModulationClass mc);
+
+    /**
+     * Check whether the given RU overlaps with the given set of RUs.
+     *
+     * @param bw the bandwidth of the PPDU
+     * @param ru the given RU allocation
+     * @param v the given set of RUs
+     * @return true if the given RU overlaps with the given set of RUs.
+     */
+    static bool DoesOverlap(MHz_u bw, RuSpec ru, const std::vector<RuSpec>& v);
+
+    /**
+     * Given the channel bandwidth and the number of stations candidate for being
+     * assigned an RU, maximize the number of candidate stations that can be assigned
+     * an RU subject to the constraint that all the stations must be assigned an RU
+     * of the same size (in terms of number of tones).
+     *
+     * @param bandwidth the channel bandwidth
+     * @param nStations the number of candidate stations. On return, it is set to
+     *                  the number of stations that are assigned an RU
+     * @param nCentral26TonesRus the number of additional 26-tone RUs that can be allocated if the
+     * returned RU size is greater than 26 tones
+     * @param mc the modulation class of the PPDU
+     * @return the RU type
+     */
+    static RuType GetEqualSizedRusForStations(MHz_u bandwidth,
+                                              std::size_t& nStations,
+                                              std::size_t& nCentral26TonesRus,
+                                              WifiModulationClass mc);
+
+    /**
+     * Find the RU allocation of the given RU type overlapping the given
+     * reference RU allocation.
+     *
+     * @param bw the bandwidth of the PPDU
+     * @param referenceRu the reference RU allocation
+     * @param searchedRuType the searched RU type
+     * @return the searched RU allocation.
+     */
+    static RuSpec FindOverlappingRu(MHz_u bw, RuSpec referenceRu, RuType searchedRuType);
+
+    /**
+     * Get whether a given RU variant is a HE RU
+     *
+     * @param ru the RU variant
+     * @return true if the RU is a HE RU, false otherwise
+     */
+    static bool IsHe(RuSpec ru);
+
+    /**
+     * Get whether a given RU variant is a EHT RU
+     *
+     * @param ru the RU variant
+     * @return true if the RU is a EHT RU, false otherwise
+     */
+    static bool IsEht(RuSpec ru);
+
+    /**
+     * Get the maximum RU type supported by a given modulation class.
+     *
+     * @param mc the modulation class
+     * @return the RU type
+     */
+    static RuType GetMaxRuType(WifiModulationClass mc);
+};
+
+/**
+ * @brief Stream insertion operator.
+ *
+ * @param os the stream
+ * @param ru the RU variant
+ * @returns a reference to the stream
+ */
+std::ostream& operator<<(std::ostream& os, const WifiRu::RuSpec& ru);
+
+} // namespace ns3
+
+#endif /* WIFI_RU_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-spectrum-phy-interface.cc ns-3.45/src/wifi/model/wifi-spectrum-phy-interface.cc
--- ns-3.44/src/wifi/model/wifi-spectrum-phy-interface.cc	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-spectrum-phy-interface.cc	2025-06-01 20:34:45.631702200 -0700
@@ -36,7 +36,7 @@
       m_centerFrequencies{},
       m_channelWidth{0},
       m_bands{},
-      m_heRuBands{}
+      m_ruBands{}
 {
     NS_LOG_FUNCTION(this << freqRange);
 }
@@ -50,7 +50,7 @@
     m_netDevice = nullptr;
     m_channel = nullptr;
     m_bands.clear();
-    m_heRuBands.clear();
+    m_ruBands.clear();
 }
 
 void
@@ -166,15 +166,15 @@
 }
 
 void
-WifiSpectrumPhyInterface::SetHeRuBands(HeRuBands&& heRuBands)
+WifiSpectrumPhyInterface::SetRuBands(RuBands&& ruBands)
 {
-    m_heRuBands = std::move(heRuBands);
+    m_ruBands = std::move(ruBands);
 }
 
-const HeRuBands&
-WifiSpectrumPhyInterface::GetHeRuBands() const
+const RuBands&
+WifiSpectrumPhyInterface::GetRuBands() const
 {
-    return m_heRuBands;
+    return m_ruBands;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/wifi-spectrum-phy-interface.h ns-3.45/src/wifi/model/wifi-spectrum-phy-interface.h
--- ns-3.44/src/wifi/model/wifi-spectrum-phy-interface.h	2025-03-09 16:55:49.803372600 -0700
+++ ns-3.45/src/wifi/model/wifi-spectrum-phy-interface.h	2025-06-01 20:34:45.631702200 -0700
@@ -132,17 +132,17 @@
     const WifiSpectrumBands& GetBands() const;
 
     /**
-     * Set the HE RU spectrum bands handled by this interface (if any)
+     * Set the RU spectrum bands handled by this interface (if any)
      *
-     * @param heRuBands the HE RU spectrum bands
+     * @param ruBands the RU spectrum bands
      */
-    void SetHeRuBands(HeRuBands&& heRuBands);
+    void SetRuBands(RuBands&& ruBands);
     /**
-     * Get the HE RU spectrum bands handled by this interface
+     * Get the RU spectrum bands handled by this interface
      *
-     * @return the HE RU spectrum bands
+     * @return the RU spectrum bands
      */
-    const HeRuBands& GetHeRuBands() const;
+    const RuBands& GetRuBands() const;
 
   private:
     void DoDispose() override;
@@ -157,7 +157,7 @@
 
     WifiSpectrumBands
         m_bands; /**< Store all the distinct spectrum bands associated with every channels widths */
-    HeRuBands m_heRuBands; /**< Store all the distinct spectrum bands associated with every RU */
+    RuBands m_ruBands; /**< Store all the distinct spectrum bands associated with every RU */
 };
 
 } // namespace ns3
